/* An example of fork()
   Jim Teresco - CS 432 - Fall 2002

   $Id: forking.c,v 1.2 2002/09/19 00:40:21 terescoj Exp $
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char *argv[]) {
  pid_t pid;
  int status;

  printf("The fork example is running: initial pid %d\n", getpid());

  /* sleep a little so we can see what's happening */
  sleep(10);

  /* This function is called once, but returns twice! */
  pid = fork();

  printf("We called fork(), return value is %d, pid is %d\n", pid, getpid());

  if (pid) {
    /* The parent process */
    printf("The parent (%d) is waiting for the child (%d) to terminate\n",
	   getpid(), pid);
    wait(&status);
    /* according to wait(2), we need to use this macro to extract
       out the exit status of the child */
    printf("The child finished with status %d\n", WEXITSTATUS(status));
  }
  else {
    /* The child process */
    printf("The child lives!  pid is %d, ppid is %d\n", getpid(), getppid());
    /* sleep for a little while so we can see what's happening */
    sleep(10);
    /* The value we pass here should go to the parent in the wait() call */
    exit(17);
  }

  /* Only the parent gets down here */
  return 0;
}

